#!/usr/bin/python
# -*- coding: utf-8 -*-

#Fichero de gestión de configuración

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import pickle
from Driza import datos

# Elementos a configurar:

	#tmpdir: Guarda la ruta del directorio de trabajo
	#rdir:   Guarda la ruta del ejecutable de R
	#vsplash: boolean que dice si aparece la ventana splash o no
	#lfichero: Lista de ficheros


class ManejadorConfig:
	"""Clase que maneja la config """
	def __init__(self):
		"""Funcion de inicialización del manejador de configuración """
		import os
		self.fichero=os.environ["HOME"]+"/.driza"
		self.parametros={}
		self.new=False #Variable que almacena si existe previamente la configuración o no
		try:
			archivo=open(self.fichero,"r")
		except: #Archivo nuevo
			self.new=True
			archivo=open(self.fichero,"w")
			pickle.dump(self.__default(),archivo)
			self.parametros=self.__default()
			archivo.close()
		else:
			self.parametros=pickle.load(archivo)
			archivo.close()

	def __default(self):
		"""Devuelve la lista de parámetros por defecto"""
		listaficheros=datos.Listaficheros(5)
		return {"tmpdir":"/tmp","rdir":"/usr/bin/R","lfichero":listaficheros,"vsplash":True}

	def __getitem__(self,valor):
		"""Definicion del operador []"""
		return self.parametros[valor]

	def __setitem__(self, clave, valor):
		"""Funcion para establecer la clave de un valor
		Definición del operador []=
		"""
		self.parametros[clave]=valor

	def save(self):
		"""Función que guarda los valores actuales en el fichero de trabajo"""
		archivo=open(self.fichero,"w")
		pickle.dump(self.parametros,archivo)
		archivo.close()

