#!/usr/bin/python
# -*- coding: utf-8 -*-

#dcalculo.py: Dialogo de realización de calculos estadísticos

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import sys
from Driza.dialog.dcalculo.ui.uidcalculo import DialogoCalculo
from qt import *
from Driza.dialog.dcalculo.wdescriptivo import WDescriptivo
from Driza.dialog.dcalculo.wjicuadrado import WJicuadrado
from Driza.dialog.dcalculo.wregresion import WRegresion
from Driza.dialog.dcalculo.wks import WKs

class DCalculo(DialogoCalculo):
	"""Dialogo de calculo
	   Solo contiene un tabwidget
	"""

	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		DialogoCalculo.__init__(self,parent,name,modal,fl)
		self.__initwidgets()
		
	def show(self,pestana=0):
		"""Muestra el dialogo de calculo, con la pestaña indicada y en la función indicada"""
		self.tabWidget2.setCurrentPage(pestana)
		DialogoCalculo.show(self)
		
	def __initwidgets(self):
		"""Inicializa los widgets y los coloca en el tab que les corresponde"""
		self.widget1=WDescriptivo(self.tab,"widgetdescriptivo",)
		self.widget2=WJicuadrado(self.tab_2,"widgetjicuadrado",)
		self.widget3=WKs(self.TabPage,"widgetks",)
		self.widget4=WRegresion(self.TabPage_3,"widgetregresion",)
		layout0=QHBoxLayout(self.tab)
		layout0.addWidget(self.widget1)
		layout1=QHBoxLayout(self.tab_2)
		layout1.addWidget(self.widget2)
		layout2=QHBoxLayout(self.TabPage)
		layout2.addWidget(self.widget3)
		layout4=QHBoxLayout(self.TabPage_3)
		layout4.addWidget(self.widget4)
				
				

