#!/usr/bin/python

# -*- coding: utf-8 -*-
#Clases que gestionan la selección

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *

class selectorsimple:
	def __init__(self,padre,cajadisponible,cajaseleccion,insercion,extraccion):
		"""Clase de inicialización, almacena los componentes"""
		self.cajadisponible=cajadisponible
		self.cajaseleccion=cajaseleccion
		self.botoninsercion=insercion
		self.botonextraccion=extraccion
		self.seleccion=[]
		self.parent=padre
		self.__conexiones()
	
	def __conexiones(self):
		self.parent.connect(self.botoninsercion,SIGNAL("clicked()"),self.__addelemento)
		self.parent.connect(self.botonextraccion,SIGNAL("clicked()"),self.__delelemento)

	def __addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		self.seleccion.append(self.cajadisponible.currentText())
		self.show()
	
	def __delelemento(self):
		self.seleccion.remove(self.cajaseleccion.currentText())
		self.show()

	def show(self):
		self.cajadisponible.clear()
		self.cajaseleccion.clear()
		for var in self.parent.driza.dato.arr_tit():
			if not var in self.seleccion:
				self.cajadisponible.insertItem(var)
		for var in self.seleccion:
			self.cajaseleccion.insertItem(var)

class selectordoble:
	def __init__(self,padre,cajadisponible1,cajadisponible2,cajaseleccion,insercion,extraccion):
		"""Clase de inicialización, almacena los componentes"""
		self.cajadisponible1=cajadisponible1
		self.cajadisponible2=cajadisponible2
		self.cajaseleccion=cajaseleccion
		self.botoninsercion=insercion
		self.botonextraccion=extraccion
		self.seleccion=[]
		self.parent=padre
		self.__conexiones()
	
	def __conexiones(self):
		self.parent.connect(self.botoninsercion,SIGNAL("clicked()"),self.__addelemento)
		self.parent.connect(self.botonextraccion,SIGNAL("clicked()"),self.__delelemento)

	def __addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		#TODO Comprobar si existe seleccion en ambas cosas
		self.seleccion.append([self.cajadisponible1.currentText(),self.cajadisponible2.currentText()])
		self.show()
	
	def __delelemento(self):
		del self.seleccion[self.cajaseleccion.currentItem()]
		self.show()

	def show(self):
		self.cajadisponible1.clear()
		self.cajadisponible2.clear()
		self.cajaseleccion.clear()
		for var in self.parent.driza.dato.arr_tit():
			self.cajadisponible1.insertItem(var)
			self.cajadisponible2.insertItem(var)
		for var in self.seleccion:
			self.cajaseleccion.insertItem(var[0].latin1()+"-"+var[1].latin1())

