#!/usr/bin/python
# -*- coding: utf-8 -*-
#Wdescriptivo.py: Este widget es el que representa las medidas descriptivas.

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA



#Los eleementos que posee son:
#ListBox1: Donde se guarda el listado total de variables
#ListBox2: Listado de variables actualmente seleccionada
#pushButton1: Boton listado1 -> listado2
#pushButton2: Boton listado1 <- listado2
#pushButton3: Aceptar
#pushButton4: Cancelar
#comboBox1: Agrupación

#checkBox1: Media?
#checkBox2: Varianza?
#checkBox3: Desviacion standard?
#checkBox4: Mediana=

#Este widget tiene que conseguir enviar información a la interfaz de salida. Enviara lo siguiente:
# -Arrays de nombre de variables
# -Diccionario con las opciones

import seleccion
from Driza.dialog.dcalculo.ui.uiwdescriptivo import WidgetDescriptivo
from qt import *

class WDescriptivo(WidgetDescriptivo):
	""" Widget para calculos descriptivos"""
	def __init__(self,parent = None,name = None,fl = 0):
		WidgetDescriptivo.__init__(self,parent,name,fl)
		self.dialogopadre=parent.parent().parent().parent()
		self.driza=parent.parent().parent().parent().parent().parent
		self.__conexiones()
		self.cajas=seleccion.selectorsimple(self,self.listBox1,self.listBox2,self.pushButton1,self.pushButton2)

	def __conexiones(self):
		"""Bloque de conexiones del widget descriptivo"""
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.__aceptar)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.__cancelar)

	def __aceptar(self):
		"""Aceptacion del dialogo. 
		Empleamos diccionario para guardar las opciones
		Comprobamos que hay variables y operaciones seleccionadas
		"""
		#Comprobamos que hay alguna variable seleccionada
		if not self.cajas.seleccion:
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna variable seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		#Comprobamos que hay alguna operacion seleccionada
		elif not self.checkBox1.isChecked() and not self.checkBox2.isChecked() and not self.checkBox3.isChecked() and not self.checkBox4.isChecked():
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna operación seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		else:
			diccionario={"media":False,"varianza":False,"desviacion":False,"mediana":False,"agruparpor":None}
			if self.checkBox1.isChecked():
				diccionario["media"]=True
			if self.checkBox2.isChecked():
				diccionario["varianza"]=True
			if self.checkBox3.isChecked():
				diccionario["desviacion"]=True
			if self.checkBox4.isChecked():
				diccionario["mediana"]=True
			if cmp(self.comboBox1.currentText(),"Ninguna"):
				diccionario["agruparpor"]=self.comboBox1.currentText().latin1()
			self.driza.calcular("descriptivo",self.cajas.seleccion,diccionario)
			self.dialogopadre.accept()

	def __cancelar(self):
		"""Cancelacion del dialogo"""
		self.dialogopadre.reject()

	def show(self):
		"""Redefinicion del show de la clase padre"""
		self.cajas.show()
		self.__showagrupacion()
		WidgetDescriptivo.show(self)

	def __showagrupacion(self):
		"""Actualiza la pestaña en la que se permite elegir la variable de agrupación"""
		self.comboBox1.clear()
		self.comboBox1.insertItem("Ninguna")
		i=0
		for x in self.driza.dato.arr_tit():
			#La variable no puede participar en el calculo
			if (self.driza.dato.get_var(i).tipo=="Booleano" or self.driza.dato.get_var(i).tipo=="Entero") and x not in self.cajas.seleccion:
				self.comboBox1.insertItem(x)
			else:
				pass #PENDIENTE
			i+=1


