#!/usr/bin/python
# -*- coding: utf-8 -*-

#wjicuadrado.py: Este widget es el que representa los contrastes con ji cuadrado.

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


#Simplemente implementa aceptar

from Driza.dialog.dcalculo.wbajuste import WBAjuste
from qt import *

class WJicuadrado(WBAjuste):
	""" Widget para contrastes de hipotesis"""
	def __init__(self,parent = None,name = None,fl = 0):
		WBAjuste.__init__(self,parent,name,fl)
		self.__conexiones()

	def __conexiones(self):
		"""Bloque de conexiones del widget jicuadrado"""
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.__aceptar)

		#SLOTS
	def __aceptar(self):
		"""Aceptacion del dialogo. 
		Empleamos diccionario para guardar las opciones
		Comprobamos que hay variables y operaciones seleccionadas
		"""
		if not self.cajas.seleccion:
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna variable seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		else:
			diccionario={"distribucion":False,"percentil":int(self.comboBox1.currentText().latin1())}
			if self.radioButton1.isChecked():
				diccionario["distribucion"]="uniforme"
			self.driza.calcular("jicuadrado",self.cajas.seleccion,diccionario)
			self.dialogopadre.accept()

