#!/usr/bin/python
# -*- coding: utf-8 -*-

#wregresion.py: Este widget es el que evalua la regresión lineal

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import seleccion
from Driza.dialog.dcalculo.ui.uiwregresion import WidgetRegresion
from qt import *

class WRegresion(WidgetRegresion):
	""" Widget para calculos de regresion"""
	def __init__(self,parent = None,name = None,fl = 0):
		WidgetRegresion.__init__(self,parent,name,fl)
		self.dialogopadre=parent.parent().parent().parent()
		self.driza=parent.parent().parent().parent().parent().parent
		self.cajas=seleccion.selectordoble(self,self.listBox1,self.listBox2,self.listBox3,self.pushButton3,self.pushButton4)
		self.__conexiones()

	def __conexiones(self):
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__aceptar)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.__cancelar)

	def __aceptar(self):
		"""Aceptacion del dialogo. 
		Empleamos diccionario para guardar las opciones
		Comprobamos que hay variables y operaciones seleccionadas
		"""
		#Comprobamos que hay alguna variable seleccionada
		if not self.cajas.seleccion:
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna variable seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		#Comprobamos que hay alguna operacion seleccionada
		else:
			diccionario={}
			self.driza.calcular("regresion",self.cajas.seleccion,diccionario)
			self.dialogopadre.accept()

	def __cancelar(self):
		"""Cancelacion del dialogo"""
		self.dialogopadre.reject()

	def show(self):
		"""Redefinicion del show de la clase padre"""
		self.cajas.show()
		WidgetRegresion.show(self)

