#!/usr/bin/python
# -*- coding: utf-8 -*-
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *
from Driza.dialog.ui.uidcasos import DialogoCasos

#Dialogo de casos

#textLabel1: Etiqueta donde poner el nombre de la variable
#lineEdit1:  zona donde escribes la nueva clave
#lineEdit2:  zona donde escribes el nuevo valor
#listBox1: Donde se muestra todo

#PushButton1: Boton aceptar
#PushButton2: Boton de cancelar
#pushButton3: Aadir la entrada a la lista
#pushButton4: Borrar una entrada de la lista

class DCasos(DialogoCasos):
	"""Dialogo de casos"""
	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		"""Inicializacin del dialogo de casos"""
		DialogoCasos.__init__(self,parent,name,modal,fl)
		self.__conexiones()
		self.listBox1.clear()
		self.variable=None

	def __conexiones(self):
		"""Bloque de conexiones"""
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.reject)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.addclave)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.borrarclave)

	def show(self,variable):
		"""Muestra el dialogo. El dialogo es nico para todas las variables"""
		self.variable=variable
		self.textLabel1.setText("Variable:"+self.parent().parent.dato.get_var(self.variable).nombre)
		self.listBox1.clear()
		for pareja in self.parent().parent.dato.get_var(variable).valores.items():
			self.listBox1.insertItem(str(pareja[0])+"      "+str(pareja[1]))
		DialogoCasos.show(self)

	def addclave(self):
		"""Aade una pareja clave:valor a la variable"""
		if self.variable!=None and self.lineEdit2.text().latin1() and self.lineEdit1.text().latin1(): #Tiene que existir la variable destino, el valor y la clave
			#De momento solo trabaja con enteros como indices
			self.parent().parent.dato.get_var(self.variable).valores[self.lineEdit1.text().latin1()]=self.lineEdit2.text().latin1()
			self.show(self.variable)
		else:
			rc = QMessageBox.warning(self,'Atencion', 'Falta el valor o clave', 'Volver al dialogo','',0)

	def borrarclave(self):
		"""Borra la clave sealada por listBox1"""
		del self.parent().parent.dato.get_var(self.variable).valores[self.listBox1.currentText().latin1().split(" ")[0]]
		self.show(self.variable)

	def accept(self):
		self.variable=None
		DialogoCasos.accept(self)

