#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#CheckBox1: vsplash

from Driza.dialog.dconfig.ui.uidconfig import DialogoConfig
from Driza.dialog.dconfig.ui.uiwconfig1 import wconfig1
from qt import *

class DConfig(DialogoConfig):
	"""Dialogo de configuracion"""
	def __init__(self,parent=None,name=None,modal=0,fl=0):
		DialogoConfig.__init__(self,parent,name,modal,fl)
		self.cambio=False
		self.listBox.clear()
		self.listBox.insertItem("General")
		#Inicializacion de widgets
		self.wgeneral=wconfig1(self.groupBox1,"ficheros",)
		#Seleccionar por defecto el valor 0 y poblarlo
		self.driza=self.parent().parent
		self.__poblarcaja(0)
		self.__conexiones()

	def accept(self):
		"""Funcion que es heredada pero conviene cambiar para preguntar si hay que guardar
		"""
		if not self.cambio:
			DialogoConfig.accept(self)
		else:
			self.cambio=False # Volvemos a ponerlo en falso
			rc = QMessageBox.information(self,'Atencion: Guardar', 'Ha cambiado la configuración, desea guardarla?', 'Guardarla','Cancelar','Dejarlo estar',0,1)
			if rc == 0:
				#Crear una interfaz usuario configuracion #DECISION DE DISEÑO, pendiente
				self.__guardarconfig()
				DialogoConfig.accept(self)
			elif rc == 2:
				DialogoConfig.reject(self)
			else:
				self.cambio=True
				
	def __poblarcaja(self,numero): # El nuemro es el indice de la listBox
		"""Puebla la caja donde se encuentra la seccion"""
		if numero==0:
			#Poblar el valor 0 (Configuracion general)
			self.groupBox1.setTitle("Ficheros")
			layout0=QHBoxLayout(self.groupBox1)
			layout0.addWidget(self.wgeneral)
			self.wgeneral.lineEdit1.setText(self.driza.config["tmpdir"])
			self.wgeneral.lineEdit2.setText(self.driza.config["rdir"])
			self.wgeneral.checkBox1.setChecked(self.driza.config["vsplash"])

	def __conexiones(self):
		"""Bloque de conexiones"""
		self.connect(self.wgeneral.lineEdit1,SIGNAL("textChanged(const QString&)"),self.__cambio)
		self.connect(self.wgeneral.lineEdit2,SIGNAL("textChanged(const QString&)"),self.__cambio)
		self.connect(self.wgeneral.checkBox1,SIGNAL("clicked()"),self.__cambio)

	def __cambio(self):
		"""Almacena si se ha producido algun cambio"""
		self.cambio=True

	def __guardarconfig(self):
		"""Guarda la configuración en el objeto que la maneja"""
		self.driza.config["tmpdir"]=str(self.wgeneral.lineEdit1.text())
		self.driza.config["rdir"]=str(self.wgeneral.lineEdit2.text())
		self.driza.config["vsplash"]=self.wgeneral.checkBox1.isChecked()
		self.driza.config.save()
