#!/usr/bin/python
# -*- coding: utf-8 -*-

#Dialogo de creacion de variables


#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#pushButton1: Boton aceptar
#pushButton2: Cancelar
#pushButton3: Boton de inclusion de funciones en caja de texto
#pushButton4 Inclusión de variable en caja de texto
#textEdit1: Caja de escritura
#listbox1: listado de variables
#listbox2: listado categoria funciones
#listbox3: listado funciones
#lineEdit1: Caja con el nombre de la variable
#lineEdit2: Caja con la descripción
#comboBox1: Caja con el tipo


from Driza.dialog.ui.uidcrevar import DialogoCrevar
from qt import *


class DCrevar(DialogoCrevar):
	"""Dialogo que crea unas variables a partir de otras"""
	def __init__(self,parent=None,name=None,modal=0,fl=0):
		"""Inicialización"""
		self.driza=parent.parent
		DialogoCrevar.__init__(self,parent,name,modal,fl)
		self.__inicializarlistatipos()
		self.__conexiones()
	

	def __conexiones(self):
		"""Bloque de conexiones"""
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.reject)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.__insertarfuncionseleccionada)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.__insertarvariableseleccionada)
		self.connect(self.comboBox1,SIGNAL("activated(int)"),self.__actualizarcajas)
		self.connect(self.listBox2,SIGNAL("selectionChanged()"),self.__actualizarlistafunciones)

	def show(self):
		"""Redefinicion del método show"""
		self.__actualizarcajas()
		DialogoCrevar.show(self)
	
	def __actualizarcajas(self):
		"""Actualiza las cajas"""
		self.__actualizarcajavars()
		self.__actualizartipofunciones()


	def __actualizarcajavars(self):
		"""Actualiza la caja de variables disponibles"""
		self.listBox1.clear()
		i=0
		j=0
		for var in self.driza.dato.arr_tit():
			if cmp(self.comboBox1.currentText().latin1(),self.driza.dato.get_var(j).tipo)==0:
				self.listBox1.insertItem(var,i)
				i+=1
			else: 
				print self.comboBox1.currentText().latin1(),self.driza.dato.get_var(j).tipo
			j+=1
	
	def __inicializarlistatipos(self):
		self.comboBox1.clear()
		from Driza import listas
		for tipo in listas.variables():
			self.comboBox1.insertItem(tipo)

	def __actualizartipofunciones(self):
		"""Actualiza la lista de tipo de funciones en funcion del tipo destino"""
		self.listBox2.clear()
		if self.comboBox1.currentText()=="Booleano":
			self.listBox2.insertItem(u"Lógicas")
		else:
			self.listBox2.insertItem(u"Aritméticas")
	
	def __insertarvariableseleccionada(self): 
		"""Coge el valor seleccionado y lo añade en la caja de texto"""
		if self.listBox1.currentItem() != -1:
			texto=self.listBox1.currentText().latin1()
			self.textEdit1.insert(texto)

	def __insertarfuncionseleccionada(self):
		"""Inserta la funcion seleccionada en la caja de texto"""
		if self.listBox3.currentItem() != -1:
			texto=self.listBox3.currentText().latin1()
			self.textEdit1.insert(texto)

	def __actualizarlistafunciones(self):
		self.listBox3.clear()
		if cmp(self.listBox2.currentText(),u"Aritméticas")==0:
			#Estamos con las aritmeticas
			self.listBox3.insertItem("+")
			self.listBox3.insertItem("-")
			self.listBox3.insertItem("*")
			self.listBox3.insertItem("/")
		elif cmp(self.listBox2.currentText(),u"Lógicas")==0:
			self.listBox3.insertItem("and")
			self.listBox3.insertItem("or")

	def accept(self):
		"""Funcion de aceptacion del dialogo"""
		# Creo un objeto con lo que me pasan a ver si hay una excepción o no
		if self.lineEdit1.text() and self.lineEdit2.text():
			try:
				compile(self.textEdit1.text().latin1(),self.driza.config["tmpdir"]+"/objetotmp",'single')
			except SyntaxError,NameError:
				#La expresión no es correcta, mostramos un mensaje de error
				QErrorMessage(self,"error").message(u"La expresión no es correcta")
			else:
				#llamar a la funcion de driza que crea la nueva variable
				self.driza.dato.app_var(self.lineEdit1.text().latin1(),self.comboBox1.currentText(),{},0,self.lineEdit2.text(),self.textEdit1.text().latin1())
				DialogoCrevar.accept(self)
				self.parent().show()
	#			import os
	#			os.remove(self.driza.config["tmpdir"]+"/objetotmp") #borro el archivo ... No existe ... PENDIENTE
		else:
			rc=QMessageBox.warning(self,'Atencion', 'No has rellenado todos los campos', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.reject()



