#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from Driza.dialog.ui.uidfiltro import DialogoFiltro
from qt import *

#Dialogo de filtrado
#contiene una etiqueta con el nombre del filtro actual: textLabel
#Una caja que muestre las variables posibles:  listBox1
#Boton de acceso rapido a la creación de variables: pushButton1
#Boton de aceptación: pushButton2
#Boton de revocación: pushButton3
#Boton de cancelación: pushButton4


class DFiltro(DialogoFiltro):
	"""Dialogo de filtrado de casos"""
	def __init__(self,parent=None,name=None,modal = 0,fl = 0):
		"""Inicializa el dialogo"""
		DialogoFiltro.__init__(self,parent,name,modal,fl)
		self.__inicializarlistbox()
		self.__conexiones()

	def show(self):
		"""Llama al show de la clase base, pero previamente selecciona la variable que ya actua de filtro"""
		self.listBox1.clear()
		for x in self.parent().parent.dato.arr_tit("Booleano"):
			self.listBox1.insertItem(x)  # Rellena con los valores actuales
		if self.parent().parent.filtro:
			self.listBox1.setSelected(self.listBox1.findItem(self.parent().parent.filtro.nombre),True)
		DialogoFiltro.show(self)

	def __conexiones(self):
		"""Las conexiones """
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__lanzavariables)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.desactivarfiltro)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.reject)

	def accept(self):
		"""Esta funcion redefine accept, activando el filtro en la clase principal driza"""
		if self.listBox1.currentItem()!=-1:
			self.parent().parent.filtro=self.parent().parent.dato.get_var(self.listBox1.currentText().latin1())
		DialogoFiltro.accept(self)
		self.parent().show() #Que se muestre el nuevo filtro

	def __inicializarlistbox(self):
		"""Simplemente vacia la listbox"""
		self.listBox1.clear()
		self.listBox1.SelectionMode(QListBox.Single)

	def __lanzavariables(self):
		"""Lanza el dialogo de variables si es requerido"""
		self.parent().dcrevar.show()

	def desactivarfiltro(self):
		"""Desactiva el filtro"""
		self.parent().parent.filtro=None
		DialogoFiltro.accept(self)

