#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006  Inmaculada Luengo Merino, Nstor Arocha Rodrguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from Driza.dialog.dgraficos.ui.uiwbarras import WidgetBarras
from qt import *

class WBarras(WidgetBarras):
	def __init__(self,parent=None,name=None,fl=0):
		self.dialogopadre=parent.parent().parent().parent()
		self.driza=parent.parent().parent().parent().parent().parent
		WidgetBarras.__init__(self,parent,name,fl)
		self.__conexiones()

	def __conexiones(self):
		"""Bloque de conexiones del widget de barras"""
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__aceptar)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.__cancelar)

	def __showcaja(self):
		"""Inicializa la caja"""
		self.comboBox1.clear()
		for variable in self.dialogopadre.parent().parent.dato.arr_tit():
			self.comboBox1.insertItem(variable)
		

	def __aceptar(self):
		"""Aceptacion del dialogo. 
		Empleamos diccionario para guardar las opciones
		Comprobamos que hay variables y operaciones seleccionadas
		"""
		diccionario={}
		diccionario["nclass"]=self.lineEdit1.text().latin1()
		#Comprobamos que hay alguna variable seleccionada
		self.driza.calcular("barras",[self.comboBox1.currentText()],diccionario)
		self.dialogopadre.accept()

	def __cancelar(self):
		self.dialogopadre.reject()

	def show(self):
		"""Redefinicion de show"""
		self.__showcaja()
		WidgetBarras.show(self)
		
