#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *
from qttable import *
from Driza.dialog.vprincipal.ui.uivprincipal import vprincipal
from Driza.dialog.dcalculo.dcalculo import DCalculo
from Driza.dialog.dconfig.dconfig import DConfig
from Driza.dialog.dfiltro import DFiltro
from Driza.dialog.dcrevar import DCrevar
from Driza.dialog.dgraficos.dgraficos import DGraficos
from Driza.dialog.dbuscar import DBuscar
from Driza.dialog.dcasos import DCasos

from Driza import listas
import string
from Driza.dialog.vprincipal import greytableitem

class VPrincipal(vprincipal):
	def __init__(self,parent): 
		"""Inicializador de la ventana principal"""
		from Driza import datos
		vprincipal.__init__(self,None)
		self.parent=parent
		#Bloque de inicialización de dialogos
		self.dcalculo = DCalculo(self,"Dialogo de calculo",0,)
		self.dfiltro = DFiltro(self,"dialogo filtrado",0,)
		self.dcrevar = DCrevar(self,"creacion variables",0,)
		self.dgraficos = DGraficos(self,"Graficos!",0,)
		self.dbuscar = DBuscar(self,"busqueda",0,)
		self.dconfig = DConfig(self,"Dialogo Config",0,)
		self.dcasos = DCasos(self,"Dialogo de casos",0,)
		#Bloque de variables de control (VARIABLES DE ESTADO)
		self.modificado = False  # Variable de control sobre si el fichero abierto ha sido modificado
		#Variables enteras que almacenan el numero de casillas deseadas para las tablas como excedente
		self.nreg=10 
		self.nvar=10
		# Configuracion de las tablas
		self.__inittabladat()
		self.__inittablavar(self.nvar)
		# Configuracion de la toolbar
		self.__inittoolbar()
		self.__conexiones()
	
	def __inittoolbar(self):
		"""Inicializa la toolbar"""
		self.boton1=QToolButton(self.Toolbar)
		self.boton1.setTextLabel("ABRIR")
	 	iconos=QIconSet()
		iconos.setIconSize(QIconSet.Small,QSize(100,100))
		iconos.setPixmap(self.parent.rutaimagenes()+"botonabrir.png",QIconSet.Small)
#		iconos.setPixmap("images/flechaabajo.png",QIconSet.Automatic,QIconSet.Normal,QIconSet.Off)
		self.boton1.setOn(True)
		self.boton1.setIconSet(iconos)
		self.boton2=QToolButton(self.Toolbar)
		self.boton2.setTextLabel("GUARDAR")
	 	iconos=QIconSet()
		iconos.setIconSize(QIconSet.Small,QSize(100,100))
		iconos.setPixmap(self.parent.rutaimagenes()+"botonguardar.png",QIconSet.Small)
		self.boton2.setOn(True)
		self.boton2.setIconSet(iconos)

	def __conexiones(self):
		"""Funcion llamada en el constructor que almacena todas las conexiones accion-funcion"""
		self.connect(self.fileExitAction,SIGNAL("activated()"),self.__salirprograma)
		self.connect(self.archivoSalirAction,SIGNAL("activated()"),self.__salirprograma)
		self.connect(self.fileOpenAction,SIGNAL("activated()"),self.abrirfichero)
		self.connect(self.fileSaveAsAction,SIGNAL("activated()"),self.__guardarcomo)
		self.connect(self.fileSaveAction,SIGNAL("activated()"),self.__guardar)
		self.connect(self.analizarMediaAction,SIGNAL("activated()"),self.__dcalculodescriptivo)
		self.connect(self.analizarBondad_de_ajusteJi_cuadradoAction,SIGNAL("activated()"),self.__dcalculojicuadrado)
		self.connect(self.AnalizarKs,SIGNAL("activated()"),self.__dcalculoks)
		self.connect(self.analizarRegresin_linealAction,SIGNAL("activated()"),self.__dcalculoregresion)
		self.connect(self.programaConfigurarAction,SIGNAL("activated()"),self.dconfig.show)
		self.connect(self.table1,SIGNAL("valueChanged(int,int)"),self.__actualizardat)
		self.connect(self.table2,SIGNAL("valueChanged(int,int)"),self.__actualizarvar)
		self.connect(self.datosFiltrarAction,SIGNAL("activated()"),self.dfiltro.show)
		self.connect(self.modificarCrear_nuevas_variablesAction,SIGNAL("activated()"),self.dcrevar.show)
		self.connect(self.graficosBarrasAction,SIGNAL("activated()"),self.dgraficos.show)
		self.connect(self.editFindAction,SIGNAL("activated()"),self.dbuscar.show)
		self.connect(self.editCopyAction,SIGNAL("activated()"),self.copy)
		self.connect(self.editCutAction,SIGNAL("activated()"),self.cut)
		self.connect(self.editPasteAction,SIGNAL("activated()"),self.paste)
		self.connect(self.editUndoAction,SIGNAL("activated()"),self.undo)
		self.connect(self.editRedoAction,SIGNAL("activated()"),self.redo)
		self.connect(self.acerca_deAcerca_deAction,SIGNAL("activated()"),self.acerca_de)
		self.connect(self.boton1,SIGNAL("clicked()"),self.abrirfichero)
		self.connect(self.boton2,SIGNAL("clicked()"),self.__guardar)


	def __inittabladat(self):
		"""Inicializa la tabla de datos"""
		self.table1.setSelectionMode(QTable.MultiRow)
		self.table1.setNumCols(16) 
		self.table1.setNumRows(64)



	def __inittablavar(self,nvars):
		"""Inicializa la tabla de variables"""
		self.table2.setSelectionMode(QTable.MultiRow)
		self.table2.setNumRows(nvars)
		titulos=self.table2.horizontalHeader()
		titulos.setLabel (0,"Nombre")
		titulos.setLabel (1,"Tipo")
		titulos.setLabel (2,"Valores")
		titulos.setLabel (3,"Valor por defecto")
		titulos.setLabel (4,u"Descripción")
		self.table2.setNumCols(5)

	def __showtablavar(self,pos=None):  
		""" Representa la variable pos en la tabla de variables. Las propiedades de la variable las lee de los datos.
		Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
		"""
		if pos:
			self.__showvar(pos)
			#Actualizacion de titulo en la tabla de datos
			self.__showtitulodat(pos)
		else:
			for n in range(self.parent.dato.num_var()):
				self.__showvar(n)
			for n in range(self.parent.dato.num_var(),self.table2.numRows()):
				for y in range(self.table2.numCols()):
					self.table2.clearCell(n,y)
			self.__showtitulodat()

	def __showvar(self,pos):
		"""Muestra una unica variable (fila) en la tabla segun el listado de variables"""
		variable=self.parent.dato.get_var(pos)
		self.table2.setItem(pos,2,self.__buttontableitem())
		self.table2.setText(pos,0,str(variable.nombre))
		self.table2.setText(pos,3,str(variable.valorpordefecto))
		self.table2.setText(pos,4,str(variable.descripcion))
		self.table2.setItem(pos,1,self.__combotableitem())	
		self.table2.item(pos,1).setCurrentItem(variable.tipo)

	def __showtabladat(self,pos=None):
		"""Muestra el dato en la posicion pos (fila)
		Lee de los datos, así que deben existir previamente
		Comprueba si esta filtrado o no para cambiar el color
		Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
		"""
		if pos:  
			#Se ha indicado la posición
			self.__showdat(pos)
		else: 
			#No se ha indicado la posicion, se rellena todo
			for x in range(self.parent.dato.num_dat()):
				self.__showdat(x)
			self.__showtitulodat()
			for x in range(self.parent.dato.num_dat(),self.table1.numRows()):
				for y in range(self.table1.numCols()):
					self.table1.clearCell(x,y)
			for x in range(self.table1.numRows()):
				for y in range(self.parent.dato.num_var(),self.table1.numCols()):
					self.table1.clearCell(x,y)

	def __showdat(self,pos):
		"""Muestra un solo dato"""
		for i in range(self.parent.dato.num_var()):
			if self.parent.filtro:
				if self.parent.dato[self.parent.filtro][pos]:
					self.table1.setText(pos,i,str(self.parent.dato[pos][i]))
				else:
					self.table1.setItem(pos,i,greytableitem.GrisTableItem(self.table1,QTableItem.OnTyping,repr(self.parent.dato[pos][i]))) # 
			else:
				self.table1.setText(pos,i,str(self.parent.dato[pos][i]))

	def __showtitulodat(self,pos=None):
		"""Actualiza los titulos de la tabla de datos segun las variables"""
		titulos=self.table1.horizontalHeader()
		if pos:
			titulos.setLabel(pos,self.parent.dato.get_var(pos).nombre)
		else:
			i=0
			for nombre in self.parent.dato.arr_tit():
				titulos.setLabel(i,nombre)
				i=i+1

	
			

	#Funciones privadas
	def __combotableitem(self,indice=0):
		"""Devuelve un nuevo objeto tipo combotableitem"""
		lista=QStringList()
		from Driza import listas
		for tipo in listas.variables():
			lista.append(tipo)
		return QComboTableItem(self.table2,lista)
	
	def __buttontableitem(self):
		"""Devuelve un objeto mixto"""
		from Driza.dialog.vprincipal import buttontableitem
		widget = buttontableitem.buttontableitem(self.table2)
		return widget


	#Slots o como se llame
	def __salirprograma(self):
		"""Funcion de salida del programa"""
		qApp.exit(0)

	def abrirfichero(self):
		""" Cuando pulsamos abrir un archivo """
		filter=""
		for fmt in listas.extensiones_fichero():
			filter=filter+"%s files (*.%s);;" % (fmt,string.lower(fmt))
		fn = QFileDialog.getOpenFileName(QString.null,filter,self,None,"Dialogo abrir fichero","")
		filename = str(fn)
		if filename:
			self.parent.cargarfichero(filename)
	
	def __guardar(self):
		"""Funcion de guardado del fichero. Si el fichero no es conocido se llama a guardarcomo"""
		if self.parent.fichero:
			self.parent.guardarfichero()
		else:
			self.__guardarcomo()

	def __guardarcomo(self):
		"""Abre un diálogo pidiendo el nombre de archivo y guarda en dicho archivo"""
		fn = QFileDialog.getSaveFileName(QString.null,QString.null,self)
		filename = str(fn)
		if filename:
			self.parent.guardarfichero(filename)

	def __insertardat(self,x,y,valor):
		"""Inserta un dato con la garantia de que ya existe el registro y la variable"""
		try:
			self.parent.dato[x][y]=valor
		except ValueError:
			rc = QMessageBox.warning(self,'Bienvenido', 'El dato no es válido')
	
	def __insertarregistro(self):
		"""Inserta un registro genérico, y ademas comprueba que no nos estamos acercando al final de la tabla"""
		self.parent.dato.app_dat()
		if self.nreg>(self.table1.numRows()-self.parent.dato.num_dat()):
			self.table1.setNumRows(self.table1.numRows()+1)

	def __insertarvariable(self):
		"""Inserta una variable genérica, y ademas comprueba que no nos acercamos a ninguno de los limites de las tablas"""
		self.parent.dato.app_var()
		if self.nvar>(self.table2.numRows()-self.parent.dato.num_var()):
			self.table2.setNumRows(self.table2.numRows()+1)
			self.table1.setNumCols(self.table1.numCols()+1)

	def __actualizardat(self,x,y):
		"""Actualiza los datos del objeto dato a partir de un cambio en la tabla de datos"""
		self.parent.guardarestado()
		from Driza import datos
		valor=self.table1.text(x,y).latin1()
		if y>=self.parent.dato.num_var():
			#Estamos trabajando sobre una variable inexistente
			for i in range(self.parent.dato.num_var(),y):
				self.__insertarvariable()
			self.parent.dato.app_var()
			self.__showtablavar() #actualizamos la tabla de variables
		if x>=self.parent.dato.num_dat():
			#no existen registros intermedios
			for i in range (self.parent.dato.num_dat(),x):  
				self.__insertarregistro()
				self.__showtabladat(i)
			self.parent.dato.app_dat()
		#Actualizamos la fila que ha utilizado el usuario
		self.__insertardat(x,y,valor)
		self.__showtabladat()

		
	def __actualizarvar(self,x,y):
		"""Funcion a que conecta con la introduccion de nuevos datos en la tabla de variables"""
		self.parent.guardarestado()
		if x>=self.parent.dato.num_var(): #Es una nueva variable
			#Variables intermedias (creadas con los valores por defecto)
			for valorintermedio in range (self.parent.dato.num_var(),x):  
				self.parent.dato.app_var()
				self.__showtablavar(valorintermedio)
			self.parent.dato.app_var()
		#Variable modificada
		variable=self.parent.dato.get_var(x)
		if y==1:   # El usuario quiere cambiar el tipo
			from Driza import variables
			textoencuestion=self.table2.text(x,y).latin1() 
			if textoencuestion == "Entero":
				nuevavariable=variables.Entero()
			elif textoencuestion == "Real":
				nuevavariable=variables.Real()
			elif textoencuestion == "Booleano":
				nuevavariable=variables.Booleano()
			elif textoencuestion == "Fecha":
				nuevavariable=variables.Booleano()
			nuevavariable.update(variable)
			self.parent.dato.set_var(x,nuevavariable)
		elif y==2: # Estamos en el caso de los casos, mejor no hacer nada ... de momento
			print "No implementado"
		else: #Restos de campos (Texto)
			variable[y]=str(self.table2.text(x,y).latin1())
		self.__showtablavar()  
		#En todos los casos, actualizamos el titulo de la tabla de datos
		self.__showtitulodat()

	def show(self):
		"""Esta funcion actualiza el contenido de las rejillas segun los datos
		Reimplementa el show de la clase base
		"""
		#Tabla de datos
		#El margen extra sugerido por las variables nvar y ndat
		self.__showtablavar()
		self.__showtabladat()
		#Titulo de datos
		vprincipal.show(self)


	def __removeselection(self,tabla):
		""" Esta funcion borra la seleccion de la tabla"""
		for seleccion in range(tabla.numSelections()):
			tabla.removeSelection(seleccion)

	def __deleteselection(self,tabla):
		""" Esta funcion borra la seleccion de la tabla,junto con los datos"""
		lista=[]
		for seleccion in range(tabla.numSelections()):
			for fila in range(tabla.selection(seleccion).topRow(),tabla.selection(seleccion).bottomRow()+1):
				lista.append(fila)
		lista.sort()
		lista.reverse()
		for fila in lista:
			del self.parent.dato[fila]
		tabla.removeSelection(seleccion)

	def __copiar(self):
		"""Esta funcion pega el contenido del clipboard en la tabla actual"""
		tablaactual=self.tabWidget2.currentPageIndex()
		if tablaactual == 0:
			tabla=self.table1
			cadena=""
			lista=[]
			for seleccion in range(tabla.numSelections()):
				for fila in range(tabla.selection(seleccion).topRow(),tabla.selection(seleccion).bottomRow()+1):
					lista.append(fila)
			lista.sort() #En la lista estan todas las filas que se nos piden y ordenadas
			for x in range(len(lista)):
				for y in range(self.parent.dato.num_var()):
					cadena+=repr(self.parent.dato[lista[x]][y])+":"
				cadena+=";"
			print cadena
			cb = QApplication.clipboard()
			cb.setData(QTextDrag(cadena))

	def copy(self):
		"""Funcion que copia y borra la seleccion"""
		self.__copiar()
		self.__removeselection(self.table1)

	
	def cut(self):
		"""Copia, borra la seleccion y su contenido"""
		self.parent.guardarestado()
		self.__copiar()
		self.__deleteselection(self.table1)
		self.show()


	def paste(self):
		"""Pega lo que haya sido copiado"""
		self.parent.guardarestado()
		cb = QApplication.clipboard()
		registro=cb.text().latin1().split(";")
		pos=self.table1.currentRow()
		del registro[-1]
		registro.reverse()
		for x in registro:
			elemento=x.split(":")
			del elemento[-1] #El ultimo elemento vacio
			lista=[]
			for valor in elemento:
				lista.append(valor)
			self.parent.dato.ins_dat(pos,lista)
			self.show()

	def closeEvent( self, ev ):
		"""Acciones que se realizaran cuando el usuario cierre la ventana"""
		self.parent.config.save()
		QWidget.closeEvent( self, ev )
	
	def acerca_de(self):
		"""Mensaje de about"""
		QMessageBox.about(self,"Acerca de Driza", u"Driza %s es una interfaz estadística\n (C) Néstor Arocha Rodríguez - Inmaculada luengo Merino\n Distribuido bajo licencia GPL" % (self.parent.version()))
	
	def undo(self):
		"""Deshace el último cambio"""
		if not self.parent.undo: self.parent.restaurarestado()
		self.show()
	
	def redo(self):
		"""Rehace el último cambio"""
		if self.parent.undo: self.parent.restaurarestado()
		self.parent.undo=False
		self.show()

	def __dcalculodescriptivo(self):
		"""Muestra el dialogo de calculo descriptivo"""
		self.dcalculo.show(0)

	def __dcalculojicuadrado(self):
		"""Muestra el dialogo ji cuadrado"""
		self.dcalculo.show(1)

	def __dcalculoks(self):
		"""Muestra el dialogo ks"""
		self.dcalculo.show(2)

	def __dcalculocmedias(self):
		"""Muestra el dialogo de comparacion de medias"""
		self.dcalculo.show(3)

	def __dcalculoregresion(self):
		"""Muestra el dialogo de regresion"""
		self.dcalculo.show(4)
