#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#Fichero manejador de ficheros
#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

class ManejadorFicheros:
	""" Interfaz entre datos y ficheros """

	def __init__(self):
		"""Inicializa el manejador de ficheros.
		Crea los objetos que se usaran para comprobar la extension de los archivos"""
		import re
		self.regexp=re.compile('.*\.pkl$')

	def __getitem__(self,fichero):
		"""Coge los datos de un fichero y los guarda en el objeto dato"""
		archivo = open(fichero, 'r')
		if self.regexp.match(fichero):
			import pickle
			datos=pickle.load(archivo) 
		archivo.close
		return datos
			
	def __setitem__(self,fichero,datos):
		"""Guarda el contenido de un objeto dato en un fichero"""
		archivo = open(fichero, 'w')
		if self.regexp.match(fichero):
			import pickle
			pickle.dump(datos,archivo)
		archivo.close()
		
