#!/usr/bin/python
# -*- coding: utf-8 -*-
#Clases de elementos correspondientes a la ventana de salida

#salida.py: Objetos relacionados con la ventana de salida

#Copyright (C) 2006  Inmaculada Luengo Merino, Nstor Arocha Rodrguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

class resultado:
	"""Esta clase es la clase padre de todos los elementos que se mostraran en la ventana de salida"""
	pass

class descriptivo(resultado):
	"""Esta clase muestra la salida de un estudio descriptivo"""
	#PENDIENTE: Aadir en el append el caso
	def __init__(self,caso=None,media=None,varianza=None,desviacion=None,mediana=None):
		"""Funcion constructora del objeto. 
		Se espera que los parametros sean tipo bool, determinando si dicho valor aparecer en la salida o no"""
		self.media=media
		self.varianza=varianza
		self.desviacion=desviacion
		self.mediana=mediana
		self.caso=False
		if caso:
			self.caso=True
		self.array=[]
	def insertarregistro(self,nombre,caso,media,varianza,desviacion,mediana):
		"""
		Funcin de insercin de un resultado. 
		Se espera que cada parmetro sea el valor numrico del resultado o None para los no disponibles
		"""
		self.array.append([nombre,caso,media,varianza,desviacion,mediana])

	def __ncols(self):
		"""Devuelve el nmero de columnas incluyendo el nombre"""
		n=1
		if self.media: n+=1
		if self.varianza: n+=1
		if self.desviacion: n+=1
		if self.mediana: n+1
		return n

	def html(self):
		"""Devuelve el html con la tabla de resultados para la operacin pedida"""
		divisor="</td><td>"
		string="<h1>Estudio descriptivo</h1><table border=\"2\"><tr><td>Variable</td>"
		if self.caso:
			string+="<td>Caso</td>"
		if self.media:
			string+="<td>Media</td>"
		if self.varianza:
			string+="<td>Varianza</td>"
		if self.desviacion:
			string+="<td>Desviacin standard</td>"
		if self.mediana:
			string+="<td>Mediana</td>"
		string+="</tr>"
		for resultado in self.array:
			string+="<tr><td>"
			string+=resultado[0]
			if self.caso:
				string+=divisor+repr(resultado[1])
			if self.media:
				string+=divisor+repr(resultado[2])
			if self.varianza:
				string+=divisor+repr(resultado[3])
			if self.desviacion:
				string+=divisor+repr(resultado[4])
			if self.mediana:
				string+=divisor+repr(resultado[5])
			string+="</td></tr>"
		string+="</table>"
		return string
		
class bondaddeajuste(resultado):
	def __init__(self):
		self.array=[]
		self.titulo=""
	def insertarregistro(self,variable,percentil,resultados):
		"""Inserta un registro"""
		self.array.append([variable,percentil,resultados])
	def html(self):
		"""Devuelve la salida en html"""
		string=""
		string+=self.titulo
		string+="<table border=\"2\"><tr><td>Variable</td><td>Percentil limite</td><td> Percentil obtenido</td><td>Conclusin</td></tr>"
		for resultado in self.array:
			string+="<tr>"
			string+="<td>"+resultado[0]+"</td>"
			string+="<td>"+repr(resultado[1])+"</td>"
			string+="<td>"+repr(resultado[2]["p.value"])+"</td>"
			if resultado[2]["p.value"]*100 > resultado[1]:
				string+="<td>Se ajusta a la distribucion</td>"
			else:
				string+="<td>No se ajusta a la distribucion</td>"
			string+="</tr>"
		string+="</table>"
		return string

class jicuadrado(bondaddeajuste):
	def __init__(self):
		"""Inicializa un resultado de una operacion ji cuadrado"""
		bondaddeajuste.__init__(self)
		self.titulo="<h1>Test de Bondad de ajuste Xi Cuadrado</h1>"
		
class ks(bondaddeajuste):
	def __init__(self):
		"""Inicializa un resultado de una operacion ji cuadrado"""
		bondaddeajuste.__init__(self)
		self.titulo="<h1>Test de Bondad de ajuste KS</h1>"

class regresion(resultado):
	def __init__(self):
		self.array=[]
		self.titulo="<h1>Test Regresin Lineal</h1>"
	def insertarregistro(self,variable1,variable2,x,b,correlacion):
		self.array.append([variable1,variable2,x,b,correlacion])
	def html(self):
		string=""
		string+=self.titulo
		string+="<table border=\"2\"><tr><td>Variable1</td><td>Variable2</td><td>x</td><td>Correlacion</td></tr>"
		for resultado in self.array:
			string+="<tr>"
			string+="<td>"+repr(resultado[0])+"</td>"
			string+="<td>"+repr(resultado[1])+"</td>"
			string+="<td>"+repr(resultado[2])+"</td>"
			string+="<td>"+repr(resultado[3])+"</td>"
			string+="</tr>"
		string+="</table>"
		return string

class barras(resultado):
	def __init__(self):
		"""Inicializa un resultado de una operacion de representacion de barras"""
		self.array=[]

	def insertarregistro(self,variable):
		self.array.append([variable])

	def html(self):
		"""Devuelve la salida en html"""
		string="<h1>Grfica de barras(Histograma) para la variable"
		string+=self.array[0][0] # No esperamos ms de una variable
		string+="</h1><img src=\"/tmp/driza001.png\">"
		return string

